'-------------------------------------------------------------------------
'---PLEASE READ THIS BEFORE USING-----------------------------------------
'-------------------------------------------------------------------------
'
' JFont v1.0 by Joe Davison
' Copyright 1997 by Davison Software (aka Joe Davison)
'
'*** Send email to: davison_soft@geocities.com ***
'
'Files included in the JFONT.ZIP file:
'    JFONT.BAS          (this file)
'    FONTDATA.DAT       (the file holding the font data)
'Make sure you know where FONTDATA.DAT is located on your hard disk.
'
'
'Syntax:
'JFont("Any text goes here", color, XCoordinate, YCoordinate, Size)
'
'Notes:
'Text can be centered by entering "999" as the XCoordinate
'Sizes range from 1 to 10. (The scale is arbitrary)
'
'JFont v2.0 will include:
'   -Multiple font styles (e.g. Bold, Italic, Color Blends, etc.)
'   -Extended ASCII codes (characters 127-255)
'   -An updated font character set
'   -Lowercase "e" and "s" currently cause problems-- this will be fixed
'   -Vertical centering and right justification
'   -Letter-spacing adjustment
'
'EMail more ideas to: davison_soft@geocities.com
'
'*** Release date of v2.0 is set for August, 1997***
'
'The most recent versions of ALL Davison Software products can be found
' at the following web address:
'      http://www.geocities.com/SunsetStrip/1595/qbasic.htm
'
'If you use this program, please email your comments and suggestions to:
'      davison_soft@geocities.com
'
'*****IMPORTANT**********************************************************
'You may use this code in your own programs provided that:
'       1. You give the author credit, which means:
'             -Include our email address ( davisos_soft@geocities.com )
'             -Include the name Davison Software
'             -(Optional) Include the author's name (Joe Davison)
'
'       2. You do not change the code in any way without
'            consulting me beforehand.
'            (I will be more than happy to allow you to
'             alter the code for your program, I just want
'             to know about it beforehand.)
'
'       3. You send me a copy of the program when it's done,
'            so I can see my font in action!
'************************************************************************
'
'Thank you for using Davison Software!
'------------------------------------------------------------------------


DECLARE SUB JFont (a$, c, XCoordinate, YCoordinate, size)

DIM SHARED charset(128, 8, 6)   'array for storing font information

RANDOMIZE TIMER
CLS


path$ = ""    'fill in a path here (end with a \)
              'program will ask for path otherwise


IF path$ = "" THEN
PRINT "Enter path to 'FONTDATA.DAT':"
PRINT "e.g. C:\DOS\QBASIC\": PRINT
INPUT path$
IF RIGHT$(path$, 1) <> "\" THEN path$ = path$ + "\"
END IF

OPEN path$ + "fontdata.dat" FOR INPUT AS #1
PRINT "FONTDATA.DAT found in "; path$

SCREEN 13
FOR a = 1 TO 126
FOR x = 1 TO 8
     
      FOR y = 1 TO 6
        INPUT #1, B
        charset(a, x, y) = B        'loads font data into 3-D array.
      NEXT y

   NEXT x
NEXT a

CLOSE

PALETTE 200, 0
PAINT (160, 100), 200

'The following are examples of how to use the routine.

CALL JFont("WITH JFont...", 80, 999, 5, 1)
CALL JFont("TEXT CAN BE PUT", 85, 999, 15, 2)
CALL JFont("IN DIFFERENT", 90, 999, 30, 3)
CALL JFont("SIZES", 95, 999, 53, 5)
CALL JFont("Can be put anywhere by using (x,y) coordinates", 65, 999, 90, 1)
CALL JFont("It won't overwrite what's underneath!", 70, 999, 100, 1)

'This sentence includes every letter of the alphabet!
CALL JFont("THE QUICK BLACK FOX JUMPS OVER THE LAZY BROWN DOG", 40, 999, 110, 1)
CALL JFont("the quick black fox jumps over the lazy brown dog", 50, 999, 120, 1)

CALL JFont("1234567890!@#$%^&*()-=[]<>{}\|?,.`", 80, 999, 130, 1)
CALL JFont("http://www.geocities.com/SunsetStrip/1595/qbasic.htm", 14, 999, 150, 1)
CALL JFont("E-Mail: davison_soft@geocities.com", 10, 999, 160, 1)
CALL JFont("Created by: Joe Davison", 15, 999, 175, 2)


col = 0: i = 1
DO

  col = col + i
  IF col <= 0 THEN i = -i
  IF col >= 30 THEN i = -i
  PALETTE 200, 65536 * col

FOR slo = 1 TO 1000: NEXT slo

LOOP UNTIL INKEY$ <> ""

END

SUB JFont (a$, c, XCoordinate, YCoordinate, size)

size = INT(size)             'No decimals allowed!
IF size > 10 THEN size = 10  'Check and fix invalid size calls
IF size < 1 THEN size = 1    'likewise for <.

YCoordinate = INT(YCoordinate / size)     'Prevent ballooning of YCoordinates
                                          'that is a result of using
                                          'size values larger than 1 for size


'Enter 999 as XCoordinate for centered text...
IF XCoordinate = 999 THEN XCoordinate = 160 - (LEN(a$) * 3 * size)

startx = XCoordinate               'set Starting X-Val for character drawing

FOR e = 1 TO LEN(a$)

   B$ = MID$(a$, e, 1)     ' read each character of the string
   a = ASC(B$)             ' get ASCII values of each character

      FOR x = 1 TO 8

         FOR y = 1 TO 6

            SELECT CASE charset(a, x, y)       'use ASCII value (a) to point
                                               'to the correct element in
                                               'the array

               CASE 0: col = 0                 ' Don't draw pixel

               CASE 1: col = c                 ' Draw pixel
              
               CASE ELSE                       ' Error!
                  CLS
                  SCREEN 9
                  BEEP
                  COLOR 4
                  PRINT "Error in FONTDATA.DAT"
                  PRINT "This could be the result of unauthorized tampering with the file."
                  PRINT "To fix: edit FONTDATA.DAT; make sure only 1's, 0's, and commas are there."
                  PRINT
                  PRINT "If you are still having trouble..."
                  PRINT "Send email to: davison_soft@geocities.com"
                  PRINT "to obtain a fresh copy of the file"
                  PRINT
                  PRINT "Program will now continue, but may exhibit erratic behavior..."
                  DO: LOOP UNTIL INKEY$ <> ""
                  SCREEN 13

            END SELECT

          IF col <> 0 THEN        'Draw a pixel!
           LINE (startx + pixelsright, (x + YCoordinate) * size)-(startx + pixelsright + (size - 1), ((x + YCoordinate) * size) + (size - 1)), col, BF
          END IF

          startx = startx + size     'Set starting X-value for next pixel
       
        NEXT y
      
       startx = XCoordinate          'reset startx for next line of pixels
    
     NEXT x
   pixelsright = pixelsright + (6 * size)   ' add pixels for next character

NEXT e

END SUB

